<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Flex</title>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<h1 class="text-center my-5">Bootstrap Flex</h1>
	<!-- 
		Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS. However, using bootstrap it is much easier and faster to implement flex because all we have to do is add the class d-flex to the parent of our flex items.

		Flex items, flex children, when adding d-flex to their parent, the items become inline and they are in a row. We can adjust their height and width not like your inline elements.

		Flex Direction:

		Can change the directionof flex items by adding flex-direction. By default, flex-row is the arrangement of flex items.

		Flex Row Reverse:
		Starts from the opposite side(right) and reverses the order of flex items.

		flex-row - default
		flex-row-reverse - starts from right to left

		Flex Column
		Arrange items from top to bottom. Default, flex items occupy the width of its parent.

		Flex Column Reverse
		Arrange Bottom to top.


	 -->

	 <h3 class="text-center">Flex Row</h3>
	<div class="bg-dark d-flex mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		
	</div>
	<div>
		<div class="bg-dark d-flex mb-4">
			<span class="bg-primary p-2">Span Flex 1</span>
			<span class="bg-danger p-2">Span Flex 2</span>
			<span class="bg-success p-2">Span Flex 3</span>
		</div>
		
	</div>
	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-column mb-4 p-4">
			<span class="bg-primary p-2">Span Flex 1</span>
			<span class="bg-danger p-2">Span Flex 2</span>
			<span class="bg-success p-2">Span Flex 3</span>
		</div>
		<h3 class="my-5 text-center">Flex Column Reverse</h3>
		<div class="d-flex flex-column-reverse bg-dark mb-4 p-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>

		<!-- Justify Content -->
		<h2 class="text-center my-5">Justify Content</h2>
		<!-- Justify Content allows us to manipulate and change the alignment of our flex items along ourmain axis. The main-axis for flex-row item is our x-axis. It allows us to horizontally align our flex-row items -->
		<h3 class="text-center my-5">Justify Content Start</h3>
		<!-- justify-content-start is the dafault value ofjustify-content for flex items and allows to align our flex items to the start of their main axis. For flex-row it starts from the left, for flex-row-reverse it starts from the right. -->
		<div class="bg-dark d-flex flex-row justify-content-start bg-dark mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-start bg-dark mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<h3 class="text-center my-5">Justify Content End</h3>
		<!-- Align our flex items where our main axis ends. For flex-row, end is from the right. For flex-row-reverse the end is from the left. -->
		<div class="bg-dark d-flex flex-row justify-content-end mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<h3 class="text-center my-5">Justify Content Center</h3>
		<!-- Aligns our flex items at the center of the main axis. The main axis for both flex-row and flex-row-reverse is the x-axis. therefore, with justify-content-center we can center our items horizontally. -->
		<div class="bg-dark d-flex flex-row justify-content-center mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<h3 class="text-center my-5">Justify Content Between</h3>
		<!-- Justify-content-between adds/distributes remaining spaces in between our items. -->
		<div class="d-flex flex-row justify-content-between bg-dark mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
			<div class="bg-warning p-2">Flex Item 4</div>
			<div class="bg-info p-2">Flex Item 5</div>
		</div>

		<div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<h3 class="text-center my-5">Justify Content Around</h3>
		<!-- Aligns our items by distributing space around your items. Means it will automatically calculate the space remaining and add that space around your items. -->
		<div class="bg-dark d-flex flex-row justify-content-around mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<!-- Align Items -->
		<h2 class="text-center">Align Items</h2>
		<!-- align-items - align your items vertically for flex-row and flex-row-reverse. -->
		<h3 class="text-center">Align Item Start</h3>
		<!-- aligns items at the start of the y axis or cross-axis for flex-row and flex-row-reverse.

			For flex-row ad flex-row-reverse, the y axis is the cross axis and the x axis is their main axis.

			 FOR FLEX-COLUMN AND FLEX-COLUMN-REVERSE, the y axis is the main axis is their cross axis.

			 For flex-row and flex-row-reverse, the start of their y axis is at the top.-->

		<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>			
		</div>
		<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>			
		</div>
		<h3 class="text-center">Align Items End</h3>
		<!-- Aligns our flex-row and flex-row-reverse items at the end of their cross axis, which is the y axis meaning they will be at the bottom. -->
		<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>			
		</div>
		<div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>			
		</div>
		<h3 class="text-center my-5">Align Items Center</h3>
		 <!-- Aligns our flex-row and flex-row-reverse items vertically at the center. -->
		<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>			
		</div>
		<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height: 50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>			
		</div>

		<h2 class="text-center">Aligning Items Horizontally and Vertically</h2>
		<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>	
		</div>
		<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		 
			<!-- Mini-Activity: -->

		<h3 class="text-center my-5">Mini Activity with Flex Row</h3>
		<div class="d-flex flex-row align-items-center justify-content-center bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>	
		<div class="d-flex flex-row align-items-center justify-content-between bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>	

		<h2 class="text-center my-5">Flex Column with Align items and Justify Content</h2>	
		<!-- For flex-row and flex-row-reverse align-items aligns vertically. Justify-content aligns horizontally.

			For flex-column and flex-column-reverse, align items aligns horizontally. Justify-content aligns vertically. -->
		<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
			
		</div>
		<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
		</div>

		<!-- Mini Activity -->
		<h3 class="text-center my-5">Mini Activity with Flex Column</h3>
		<div class="d-flex flex-column justify-content-end bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
		</div>
		<div class="d-flex flex-column align-items-end bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
		</div>

		<h3 class="text-center my-5">Flex Column with Justify Content Between and Around</h3>
		<div class="d-flex flex-column justify-content-between bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
		</div>
		<div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
		</div>

		<h3 class="text-center my-5">Flex Wrap</h3>
		<div class="d-flex flex-row flex-wrap bg-dark mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
			
		</div>


<!-- JS Dependencies -->
<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>